/***
 * Excerpted from "Pragmatic Guide to Subversion",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit http://www.pragmaticprogrammer.com/titles/pg_svn for more book information.
***/
package util;

import com.mongodb.BasicDBObject;
import com.mongodb.DB;
import com.mongodb.DBCollection;

import java.util.Random;

public class populator {

    private final DB db;
    private final long docCount;

    public populator(DB db, long docCount) {
        this.db = db;
        this.docCount = docCount;
    }

    public void populateDb() {

        DBCollection collection = db.getCollection("test_collection");


        Random r = new Random(42);

        while (collection.getCount() < docCount) {

            BasicDBObject doc = new BasicDBObject();

            doc.put("name", "some item");
            doc.put("type", "item");
            doc.put("some_id", r.nextInt(50000));

            BasicDBObject info = new BasicDBObject();

            info.put("x", 203);
            info.put("y", 102);
            info.put("z", "flibble");

            doc.put("info", info);

            collection.insert(doc);
        }
    }
}
